using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using lpsolve55;

namespace LinearProgramming
{
    /// <summary>
    /// A summand of the objective function.
    /// </summary>
    public class ObjFunctionSummand : Summand
    {
        LinearSpec ls;

        /// <summary>
        /// The summmand's coefficient.
        /// </summary>
        public override double Coeff
        {
            get { return coeff; }
            set
            {
                coeff = value;
                ls.UpdateObjFunction();
            }
        }

        /// <summary>
        /// The summand's variable.
        /// </summary>
        public override Variable Var
        {
            get { return var; }
            set
            {
                var = value;
                ls.UpdateObjFunction();
            }
        }

        internal ObjFunctionSummand(LinearSpec ls, double coeff, Variable var)
            : base(coeff, var)
        {
            this.ls = ls;
        }

        /// <summary>
        /// Removes the summand from the objective function.
        /// </summary>
        public void Remove()
        {
            ls.ObjFunctionSummands.Remove(this);
            ls.UpdateObjFunction();
        }
    }
}
